#include "courselib.h"
#include <cmath>
#include "TH1.h"
#include "TH2.h"
#include "TFile.h" 
#include "TCanvas.h"
#include <TApplication.h>
#include <TStyle.h>
#include <TROOT.h>
#include <iostream>
using namespace std;

/*
	Cosntructing a random number generator
*/


int main(int argc,char **argv)
{
      TApplication* gMyRootApp = new TApplication("My ROOT Application", &argc, argv);
	int n1, npoints = 100000;
      double ia=205,ic=29573,im=139968,last=4711;
 	double x,y;
      double xlow=0.,xup=1.,ylow=0.,yup=1;
#define LVEC 2
	double rvec[LVEC];
//               TH1F("label","title",nr of bins, xlow,xhigh )
      TH2F *histo1 = new TH2F("congruental random numbers","congruental rnadom numbers ",100, xlow, xup, 100, ylow, yup);
      TH2F *histo2 = new TH2F("RANLUX","RANLUX",100, xlow, xup, 100, ylow, yup);
      
// initialise random number generator
//    rlxd_init( luxory level, seed )
      rlxd_init(2,32767);
      
	for ( n1 = 0; n1 < npoints; n1++ ) {
//   construct random numbers according the formula in exercise 1
// construct here two random numbers according to the congruential method
		last = fmod(ia*last+ic,im);
//            cout << " i1 = "<< ia*last+ic << " im = " << im << " result =" << last << endl; 
//            if ( last == 0. ){ last = fmod(ia*last+ic,im);}
            x = last/im;
		last = fmod(ia*last+ic,im);
//            if ( last == 0. ){ last = fmod(ia*last+ic,im);}
            y = last/im;
// fill the 2 random numbers into a scatter plot to compare the correlation
	      histo1->Fill(x,y);
//            cout << " x,y " << x << " " <<  y  << endl;             
// next use the ranlux generator and compare also the 2 random numbers
            ranlxd(rvec,LVEC);
		x = rvec[0];
		y = rvec[1];
	      histo2->Fill(x,y);
	}

      cout<<" Congruential Random number generator "<< endl;
      TCanvas *c = new TCanvas("ctest", "" ,0, 0, 1000, 500);
// divide the canvas in 1 parts in x and 1 in y
      c -> Divide(2,1);
//enter the first part of the canvas (upper left)
      c -> cd(1);
      c-> Draw();
      histo1 -> Draw();
      c -> cd(2);
      histo2 -> Draw();
      c->WaitPrimitive();
      c-> Print("example1.pdf");
      gMyRootApp->SetReturnFromRun(true);
//    write histogramm out to file
      TFile file("output-example1.root","RECREATE");
      histo1->Write();
      file.Close();
	return(0);
}

