#include "courselib.h"
#include <cmath>
#include "TH1.h"
#include "TFile.h" 
#include "TCanvas.h"
#include <TApplication.h>
#include <TStyle.h>
#include <TROOT.h>
#include <iostream>
using namespace std;

/*
	Cosntructing a gauss random number generator, by adding 
      several random numbers.

	The random number generator is RANLUX by M. Luescher.
      M. Lscher, A portable high-quality random number generator 
      for lattice field theory simulations, 
      Computer Physics Communications 79 (1994) 100  
	http://luscher.web.cern.ch/luscher/ranlux/index.html      
*/


int main(int argc,char **argv)
{
      TApplication* gMyRootApp = new TApplication("My ROOT Application", &argc, argv);
	int n1, npoints = 1000000;
      int n2 ;
 	double x;
#define LVEC 40
	double rvec[LVEC];
      
      
//               TH1F("label","title",nr of bins, xlow,xhigh )
      TH1F *histo1 = new TH1F("r1","r1",100, -6, 6.);
      TH1F *histo2 = new TH1F("r2","r3",100, -6, 6.);
      TH1F *histo3 = new TH1F("r3","r3",100, -6, 6.);
      TH1F *histo6 = new TH1F("r6","r6",100, -6, 6.);
      TH1F *histo10 = new TH1F("r10","r10",100, -6, 6.);
      TH1F *histo12 = new TH1F("r12","r12",100, -6, 6.);
      TH1F *histo20 = new TH1F("r20","r20",100, -6, 6.);
      
      x= 0;
// initialise random number generator
//    rlxd_init( luxory level, seed )
      rlxd_init(2,32767);
	for ( n1 = 0; n1 < npoints; n1++ ) {
      ranlxd(rvec,LVEC);
// here calculate the sum over the random numbers and fill them into the histos
// calcualte it for the sum over 1,3,6,10,12,20,40 random numbers
// in root then fit the distribution and determine the mean and sigma
      	x = 0;
		x = rvec[1];
		histo1->Fill((x-0.5)/sqrt(1./12.));
            x=0;
            for ( n2 = 0; n2 < 2 ; n2++ ) {
            x = x+rvec[n2];
            }
		histo2->Fill((x - 1 )/sqrt(2./12.));
            x=0;            
            for ( n2 = 0; n2 < 3 ; n2++ ) {
            x = x+rvec[n2];
            }
		histo3->Fill((x - 1.5 )/sqrt(3./12.));
            x=0;
            for ( n2 = 0; n2 < 6 ; n2++ ) {
            x = x+rvec[n2];
            }
		histo6->Fill((x - 3.0 )/sqrt(6./12.));
            x=0;
            for ( n2 = 0; n2 < 10 ; n2++ ) {
            x = x+rvec[n2];
            }
		histo10->Fill((x - 5)/sqrt(10./12.));
            x=0;
            for ( n2 = 0; n2 < 12 ; n2++ ) {
            x = x+rvec[n2];
            }
		histo12->Fill((x - 6)/sqrt(12./12.));
            x=0;
            for ( n2 = 0; n2 < 20 ; n2++ ) {
            x = x+rvec[n2];
            }
		histo20->Fill((x - 10)/sqrt(20./12.));
            x=0;
//                                  
	}

      cout<<" Gauss Random number generator "<< endl;
      TCanvas *c = new TCanvas("ctest", "" ,0, 0, 1000, 500);
// divide the canvas in 1 parts in x and 1 in y
      c -> Divide(2,3);
//enter the first part of the canvas (upper left)
      c -> cd(1);
      c-> Draw();
      histo1 -> Draw();
      c -> cd(2);
      histo2 -> Draw();
      c -> cd(3);
      histo3 -> Draw();
      c -> cd(4);
      histo6 -> Draw();
      c -> cd(5);
      histo10 -> Draw();
      c -> cd(6);
      histo12 -> Draw();
      gMyRootApp->SetReturnFromRun(true);
      c->WaitPrimitive();
      c-> Print("example2.pdf");
      
//    write histogramm out to file
      TFile file("output-example2.root","RECREATE");
      histo1->Write();
      histo2->Write();
      histo3->Write();
      histo6->Write();
      histo10->Write();
      histo12->Write();
      histo20->Write();
      file.Close();
	return(0);
}

