#include "courselib.h"
#include <cmath>
#include "TH1.h"
#include "TFile.h" 
#include <iostream>
using namespace std;

/*
	Testing Monte Carlo integration.
	We have a test function:  g0=1
      we calculate the integral \int_0^x\int_0^1dxdy

	We calculate the result and its error.
      
	The random number generator is RANLUX by M. Luescher.
      M. Lscher, A portable high-quality random number generator 
      for lattice field theory simulations, 
      Computer Physics Communications 79 (1994) 100  
*/



int main(int argc,char **argv)
{
	int n1, npoints = 10000000;
      double nhit, Int, x, y, sigma2, error;
#define LVEC 2
	double rvec[LVEC];
// initialise random number generator
//    rlxd_init( luxory level, seed )
      rlxd_init(2,32767);
      
      nhit = 0;
      
	for ( n1 = 0; n1 < npoints; n1++ ) {
            ranlxd(rvec,LVEC);
//    insert here the values for x,y and the rejection condition                              
		x = rvec[0];
		y = rvec[1];
            if ( y < x ) { 
            
            nhit = nhit + 1;
            } 
//                                  
	}

      Int = nhit/npoints;
// the uncertainty is calcualted from a Binominal distribution
      sigma2 = (1. - nhit/npoints)/nhit ;
      error = sqrt(sigma2)*Int ;
      cout<<" integral for  is: "<<Int<<"+/-"<< error<<endl;
      cout<<" true integral  is : 0.5 "<< endl;
	return(0);
}

